function K=cc(Lambda1,Lambda2)
k=size(Lambda1,2); % number of factors
theta=NaN(k,1);
for i=1:k
    L1=Lambda1(:,i);
    L2=Lambda2(:,i);
    NUM = sum(L1.*L2);
    DEN = sqrt(sum(L1.^2).*sum(L2.^2));
    theta(i)=NUM/DEN;
end
K=sum(theta)/k;