% function for estimating Cohen's d
function cd = cohend(X1,X2)
X1=X1(~isnan(X1));
X2=X2(~isnan(X2));
M1=mean(X1);
M2=mean(X2);
n1=length(X1);
n2=length(X2);
SDpooled= sqrt((std(X1)^2*(n1-1)+std(X2)^2*(n2-1))/(n1+n2-2));
cd=(M1-M2)/SDpooled;
