% Maximum likelihood factor analysis algorithm -- Marcus, 1993

% enter r matrix into  r
% specify number of factors (k)

% specify number of factors

[A,L,A]=svd(r);  % preliminary singular value decomposition of r
A1=A(:,1:nfactors)*sqrt(L(1:nfactors,1:nfactors));   % PCA loadings
Uni=diag(diag(r-A1*A1'));     % Uniqueness matrix
Rh1=sqrt(inv(Uni))*(r-Uni)*sqrt(inv(Uni)); % Matrix to iterate
[A,L,A]=svd(Rh1);  % First estimate of Maximum Likelihood Loadings
A1=sqrt(Uni)*A(:,1:nfactors)*sqrt(L(1:nfactors,1:nfactors)); % Begin loadings

for i=1:itermax
   Uni=diag(diag(r-A1*A1'));
   Rh1=sqrt(inv(Uni))*(r-Uni)*sqrt(inv(Uni));
   [A,L,A]=svd(Rh1);
   A2=sqrt(Uni)*A(:,1:nfactors)*sqrt(L(1:nfactors,1:nfactors));
   if max(max(abs(A1-A2)))<tol;break;end
   A1=A2;
end

Com=diag(A1*A1');  % communalities
lding = A1;